AbstractStandardBasicType (Hibernate JavaDocs)
Date: 2012-04-05

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.hibernate.type
Class AbstractStandardBasicType<T>

    java.lang.Object
      org.hibernate.type.AbstractStandardBasicType<T>

All Implemented Interfaces:
  Serializable, BasicType, StringRepresentableType<T>, Type, XmlRepresentableType<T>

Direct Known Subclasses:
  AbstractSingleColumnStandardBasicType

    public abstract class AbstractStandardBasicType<T>

extends Object
implements BasicType, StringRepresentableType<T>, XmlRepresentableType<T>

TODO : javadoc

See Also:
  Serialized Form

Constructor Summary
`AbstractStandardBasicType(SqlTypeDescriptor sqlTypeDescriptor, JavaTypeDescriptor<T> javaTypeDescriptor)`

Method Summary
`Object` | `assemble(Serializable cached, SessionImplementor session, Object owner)` Reconstruct the object from its disassembled state.
`void` | `beforeAssemble(Serializable cached, SessionImplementor session)` Called before assembling a query result set from the query cache, to allow batch fetching of entities missing from the second-level cache.
`int` | `compare(Object x, Object y)` Perform a `Comparator` style comparison between values
`Object` | `deepCopy(Object value, SessionFactoryImplementor factory)` Return a deep copy of the persistent state, stopping at entities and at collections.
`protected T` | `deepCopy(T value)`
`Size[]` | `defaultSizes(Mapping mapping)` Defines the column sizes to use according to this type if the user did not explicitly say (and if no `Type.dictatedSizes(org.hibernate.engine.spi.Mapping)` were given).
`Size[]` | `dictatedSizes(Mapping mapping)` Return the column sizes dictated by this type.
`Serializable` | `disassemble(Object value, SessionImplementor session, Object owner)` Return a disassembled representation of the object.
`T` | `fromString(String string)`
`T` | `fromStringValue(String xml)` Consume the given string representation back into this types java form.
`Object` | `fromXMLNode(org.dom4j.Node xml, Mapping factory)` Parse the XML representation of an instance.
`T` | `fromXMLString(String xml, Mapping factory)`
`Object` | `get(ResultSet rs, String name, SessionImplementor session)`
`int` | `getColumnSpan(Mapping mapping)` How many columns are used to persist this type.
`protected static Size` | `getDefaultSize()`
`protected Size` | `getDictatedSize()`
`int` | `getHashCode(Object x)` Get a hash code, consistent with persistence "equality".
`int` | `getHashCode(Object x, SessionFactoryImplementor factory)` Get a hash code, consistent with persistence "equality".
`JavaTypeDescriptor<T>` | `getJavaTypeDescriptor()`
`protected MutabilityPlan<T>` | `getMutabilityPlan()`
`String[]` | `getRegistrationKeys()` Get the names under which this type should be registered in the type registry.
`protected T` | `getReplacement(T original, T target, SessionImplementor session)`
`Class` | `getReturnedClass()` The class returned by `Type.nullSafeGet(java.sql.ResultSet, java.lang.String[], org.hibernate.engine.spi.SessionImplementor, java.lang.Object)` methods.
`Type` | `getSemiResolvedType(SessionFactoryImplementor factory)` As part of 2-phase loading, when we perform resolving what is the resolved type for this type? Generally speaking the type and its semi-resolved type will be the same.
`SqlTypeDescriptor` | `getSqlTypeDescriptor()`
`Object` | `hydrate(ResultSet rs, String[] names, SessionImplementor session, Object owner)` Extract a value from the JDBC result set.
`boolean` | `isAnyType()` Return true if the implementation is castable to `AnyType`.
`boolean` | `isAssociationType()` Return true if the implementation is castable to `AssociationType`.
`boolean` | `isCollectionType()` Return true if the implementation is castable to `CollectionType`.
`boolean` | `isComponentType()` Return true if the implementation is castable to `CompositeType`.
`protected boolean` | `isDirty(Object old, Object current)`
`boolean` | `isDirty(Object old, Object current, boolean[] checkable, SessionImplementor session)` Should the parent be considered dirty, given both the old and current value?
`boolean` | `isDirty(Object old, Object current, SessionImplementor session)` Should the parent be considered dirty, given both the old and current value?
`boolean` | `isEntityType()` Return true if the implementation is castable to `EntityType`.
`boolean` | `isEqual(Object one, Object another)` Compare two instances of the class mapped by this type for persistence "equality" (equality of persistent state).
`boolean` | `isEqual(Object x, Object y, SessionFactoryImplementor factory)` Compare two instances of the class mapped by this type for persistence "equality" (equality of persistent state).
`boolean` | `isModified(Object oldHydratedState, Object currentState, boolean[] checkable, SessionImplementor session)` Has the value been modified compared to the current database state? The difference between this and the `Type.isDirty(java.lang.Object, java.lang.Object, org.hibernate.engine.spi.SessionImplementor)` methods is that here we need to account for "partially" built values.
`boolean` | `isMutable()` Are objects of this type mutable.
`boolean` | `isSame(Object x, Object y)` Compare two instances of the class mapped by this type for persistence "equality" (equality of persistent state) taking a shortcut for entity references.
`boolean` | `isXMLElement()`
`Object` | `nullSafeGet(ResultSet rs, String[] names, SessionImplementor session, Object owner)` Extract a value of the `mapped class` from the JDBC result set.
`T` | `nullSafeGet(ResultSet rs, String name, SessionImplementor session)`
`Object` | `nullSafeGet(ResultSet rs, String name, SessionImplementor session, Object owner)` Extract a value of the `mapped class` from the JDBC result set.
`protected T` | `nullSafeGet(ResultSet rs, String name, WrapperOptions options)`
`void` | `nullSafeSet(PreparedStatement st, Object value, int index, SessionImplementor session)` Bind a value represented by an instance of the `mapped class` to the JDBC prepared statement.
`protected void` | `nullSafeSet(PreparedStatement st, Object value, int index, WrapperOptions options)`
`protected boolean` | `registerUnderJavaType()`
`protected SqlTypeDescriptor` | `remapSqlTypeDescriptor(WrapperOptions options)`
`Object` | `replace(Object original, Object target, SessionImplementor session, Object owner, Map copyCache)` During merge, replace the existing (target) value in the entity we are merging to with a new (original) value from the detached entity we are merging.
`Object` | `replace(Object original, Object target, SessionImplementor session, Object owner, Map copyCache, ForeignKeyDirection foreignKeyDirection)` During merge, replace the existing (target) value in the entity we are merging to with a new (original) value from the detached entity we are merging.
`Object` | `resolve(Object value, SessionImplementor session, Object owner)` The second phase of 2-phase loading.
`Object` | `semiResolve(Object value, SessionImplementor session, Object owner)` Given a hydrated, but unresolved value, return a value that may be used to reconstruct property-ref associations.
`void` | `set(PreparedStatement st, T value, int index, SessionImplementor session)`
`void` | `setToXMLNode(org.dom4j.Node node, Object value, SessionFactoryImplementor factory)` A representation of the value to be embedded in an XML element.
`int[]` | `sqlTypes(Mapping mapping)` Return the JDBC types codes (per `Types`) for the columns mapped by this type.
`boolean[]` | `toColumnNullness(Object value, Mapping mapping)` Given an instance of the type, return an array of boolean, indicating which mapped columns would be null.
`String` | `toLoggableString(Object value, SessionFactoryImplementor factory)` Generate a representation of the value for logging purposes.
`String` | `toString(T value)` Render the value to the string representation.
`String` | `toXMLString(T value, SessionFactoryImplementor factory)`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface org.hibernate.type.Type
`getName, nullSafeSet`

Constructor Detail

### AbstractStandardBasicType

    public AbstractStandardBasicType(SqlTypeDescriptor sqlTypeDescriptor,
                                     JavaTypeDescriptor<T> javaTypeDescriptor)

Method Detail

### fromString

    public T fromString(String string)

### toString

    public String toString(T value)

  Description copied from interface: `StringRepresentableType`
  Render the value to the string representation.

  Specified by:
    `toString` in interface `StringRepresentableType<T>`
  Parameters:
    `value` - The value to render to string.
  Returns:
    The string representation

### fromStringValue

    public T fromStringValue(String xml)
                      throws HibernateException

  Description copied from interface: `StringRepresentableType`
  Consume the given string representation back into this types java form.

  Specified by:
    `fromStringValue` in interface `StringRepresentableType<T>`
  Parameters:
    `xml` - The string representation to be consumed.
  Returns:
    The java type representation
  Throws:
    `HibernateException` - Problem consuming

### toXMLString

    public String toXMLString(T value,
                              SessionFactoryImplementor factory)
                       throws HibernateException

  Specified by:
    `toXMLString` in interface `XmlRepresentableType<T>`
  Throws:
    `HibernateException`

### fromXMLString

    public T fromXMLString(String xml,
                           Mapping factory)
                    throws HibernateException

  Specified by:
    `fromXMLString` in interface `XmlRepresentableType<T>`
  Throws:
    `HibernateException`

### getMutabilityPlan

    protected MutabilityPlan<T> getMutabilityPlan()

### getReplacement

    protected T getReplacement(T original,
                               T target,
                               SessionImplementor session)

### toColumnNullness

    public boolean[] toColumnNullness(Object value,
                                      Mapping mapping)

  Description copied from interface: `Type`
  Given an instance of the type, return an array of boolean, indicating which mapped columns would be null.

  Specified by:
    `toColumnNullness` in interface `Type`
  Parameters:
    `value` - an instance of the type
    `mapping` - The mapping abstraction
  Returns:
    array indicating column nullness for a value instance

### getRegistrationKeys

    public String[] getRegistrationKeys()

  Description copied from interface: `BasicType`
  Get the names under which this type should be registered in the type registry.

  Specified by:
    `getRegistrationKeys` in interface `BasicType`
  Returns:
    The keys under which to register this type.

### registerUnderJavaType

    protected boolean registerUnderJavaType()

### getDefaultSize

    protected static Size getDefaultSize()

### getDictatedSize

    protected Size getDictatedSize()

### getJavaTypeDescriptor

    public final JavaTypeDescriptor<T> getJavaTypeDescriptor()

### getSqlTypeDescriptor

    public final SqlTypeDescriptor getSqlTypeDescriptor()

### getReturnedClass

    public final Class getReturnedClass()

  Description copied from interface: `Type`
  The class returned by `Type.nullSafeGet(java.sql.ResultSet, java.lang.String[], org.hibernate.engine.spi.SessionImplementor, java.lang.Object)` methods. This is used to establish the class of an array of this type.

  Specified by:
    `getReturnedClass` in interface `Type`
  Returns:
    The java type class handled by this type.

### getColumnSpan

    public final int getColumnSpan(Mapping mapping)
                            throws MappingException

  Description copied from interface: `Type`
  How many columns are used to persist this type. Always the same as `sqlTypes(mapping).length`

  Specified by:
    `getColumnSpan` in interface `Type`
  Parameters:
    `mapping` - The mapping object :/
  Returns:
    The number of columns
  Throws:
    `MappingException` - Generally indicates an issue accessing the passed mapping object.

### sqlTypes

    public final int[] sqlTypes(Mapping mapping)
                         throws MappingException

  Description copied from interface: `Type`
  Return the JDBC types codes (per `Types`) for the columns mapped by this type.

  NOTE: The number of elements in this array matches the return from `Type.getColumnSpan(org.hibernate.engine.spi.Mapping)`.

  Specified by:
    `sqlTypes` in interface `Type`
  Parameters:
    `mapping` - The mapping object :/
  Returns:
    The JDBC type codes.
  Throws:
    `MappingException` - Generally indicates an issue accessing the passed mapping object.

### dictatedSizes

    public Size[] dictatedSizes(Mapping mapping)
                         throws MappingException

  Description copied from interface: `Type`
  Return the column sizes dictated by this type. For example, the mapping for a `char`/`Character` would have a dictated length limit of 1; for a string-based `UUID` would have a size limit of 36; etc.

  NOTE: The number of elements in this array matches the return from `Type.getColumnSpan(org.hibernate.engine.spi.Mapping)`.

  Specified by:
    `dictatedSizes` in interface `Type`
  Parameters:
    `mapping` - The mapping object :/
  Returns:
    The dictated sizes.
  Throws:
    `MappingException` - Generally indicates an issue accessing the passed mapping object.

### defaultSizes

    public Size[] defaultSizes(Mapping mapping)
                        throws MappingException

  Description copied from interface: `Type`
  Defines the column sizes to use according to this type if the user did not explicitly say (and if no `Type.dictatedSizes(org.hibernate.engine.spi.Mapping)` were given).

  NOTE: The number of elements in this array matches the return from `Type.getColumnSpan(org.hibernate.engine.spi.Mapping)`.

  Specified by:
    `defaultSizes` in interface `Type`
  Parameters:
    `mapping` - The mapping object :/
  Returns:
    The default sizes.
  Throws:
    `MappingException` - Generally indicates an issue accessing the passed mapping object.

### isAssociationType

    public final boolean isAssociationType()

  Description copied from interface: `Type`
  Return true if the implementation is castable to `AssociationType`. This does not necessarily imply that the type actually represents an association. Essentially a polymorphic version of `(type instanceof AssociationType.class)`

  Specified by:
    `isAssociationType` in interface `Type`
  Returns:
    True if this type is also an `AssociationType` implementor; false otherwise.

### isCollectionType

    public final boolean isCollectionType()

  Description copied from interface: `Type`
  Return true if the implementation is castable to `CollectionType`. Essentially a polymorphic version of `(type instanceof CollectionType.class)`

  A `CollectionType` is additionally an `AssociationType`; so if this method returns true, `Type.isAssociationType()` should also return true.

  Specified by:
    `isCollectionType` in interface `Type`
  Returns:
    True if this type is also an `CollectionType` implementor; false otherwise.

### isComponentType

    public final boolean isComponentType()

  Description copied from interface: `Type`
  Return true if the implementation is castable to `CompositeType`. Essentially a polymorphic version of `(type instanceof CompositeType.class)`. A component type may own collections or associations and hence must provide certain extra functionality.

  Specified by:
    `isComponentType` in interface `Type`
  Returns:
    True if this type is also an `CompositeType` implementor; false otherwise.

### isEntityType

    public final boolean isEntityType()

  Description copied from interface: `Type`
  Return true if the implementation is castable to `EntityType`. Essentially a polymorphic version of `(type instanceof EntityType.class)`.

  An `EntityType` is additionally an `AssociationType`; so if this method returns true, `Type.isAssociationType()` should also return true.

  Specified by:
    `isEntityType` in interface `Type`
  Returns:
    True if this type is also an `EntityType` implementor; false otherwise.

### isAnyType

    public final boolean isAnyType()

  Description copied from interface: `Type`
  Return true if the implementation is castable to `AnyType`. Essentially a polymorphic version of `(type instanceof AnyType.class)`.

  An `AnyType` is additionally an `AssociationType`; so if this method returns true, `Type.isAssociationType()` should also return true.

  Specified by:
    `isAnyType` in interface `Type`
  Returns:
    True if this type is also an `AnyType` implementor; false otherwise.

### isXMLElement

    public final boolean isXMLElement()

  Specified by:
    `isXMLElement` in interface `Type`

### isSame

    public final boolean isSame(Object x,
                                Object y)

  Description copied from interface: `Type`
  Compare two instances of the class mapped by this type for persistence "equality" (equality of persistent state) taking a shortcut for entity references.

  For most types this should equate to an `equals` check on the values. For associations the implication is a bit different. For most types it is conceivable to simply delegate to `Type.isEqual(java.lang.Object, java.lang.Object)`

  Specified by:
    `isSame` in interface `Type`
  Parameters:
    `x` - The first value
    `y` - The second value
  Returns:
    True if there are considered the same (see discussion above).

### isEqual

    public final boolean isEqual(Object x,
                                 Object y,
                                 SessionFactoryImplementor factory)

  Description copied from interface: `Type`
  Compare two instances of the class mapped by this type for persistence "equality" (equality of persistent state).

  This should always equate to some form of comparison of the value's internal state. As an example, for something like a date the comparison should be based on its internal "time" state based on the specific portion it is meant to represent (timestamp, date, time).

  Specified by:
    `isEqual` in interface `Type`
  Parameters:
    `x` - The first value
    `y` - The second value
    `factory` - The session factory
  Returns:
    True if there are considered equal (see discussion above).

### isEqual

    public final boolean isEqual(Object one,
                                 Object another)

  Description copied from interface: `Type`
  Compare two instances of the class mapped by this type for persistence "equality" (equality of persistent state).

  This should always equate to some form of comparison of the value's internal state. As an example, for something like a date the comparison should be based on its internal "time" state based on the specific portion it is meant to represent (timestamp, date, time).

  Specified by:
    `isEqual` in interface `Type`
  Parameters:
    `one` - The first value
    `another` - The second value
  Returns:
    True if there are considered equal (see discussion above).

### getHashCode

    public final int getHashCode(Object x)

  Description copied from interface: `Type`
  Get a hash code, consistent with persistence "equality". Again for most types the normal usage is to delegate to the value's `hashCode`.

  Specified by:
    `getHashCode` in interface `Type`
  Parameters:
    `x` - The value for which to retrieve a hash code
  Returns:
    The hash code

### getHashCode

    public final int getHashCode(Object x,
                                 SessionFactoryImplementor factory)

  Description copied from interface: `Type`
  Get a hash code, consistent with persistence "equality". Again for most types the normal usage is to delegate to the value's `hashCode`.

  Specified by:
    `getHashCode` in interface `Type`
  Parameters:
    `x` - The value for which to retrieve a hash code
    `factory` - The session factory
  Returns:
    The hash code

### compare

    public final int compare(Object x,
                             Object y)

  Description copied from interface: `Type`
  Perform a `Comparator` style comparison between values

  Specified by:
    `compare` in interface `Type`
  Parameters:
    `x` - The first value
    `y` - The second value
  Returns:
    The comparison result. See `Comparator.compare(T, T)` for a discussion.

### isDirty

    public final boolean isDirty(Object old,
                                 Object current,
                                 SessionImplementor session)

  Description copied from interface: `Type`
  Should the parent be considered dirty, given both the old and current value?

  Specified by:
    `isDirty` in interface `Type`
  Parameters:
    `old` - the old value
    `current` - the current value
    `session` - The session from which the request originated.
  Returns:
    true if the field is dirty

### isDirty

    public final boolean isDirty(Object old,
                                 Object current,
                                 boolean[] checkable,
                                 SessionImplementor session)

  Description copied from interface: `Type`
  Should the parent be considered dirty, given both the old and current value?

  Specified by:
    `isDirty` in interface `Type`
  Parameters:
    `old` - the old value
    `current` - the current value
    `checkable` - An array of booleans indicating which columns making up the value are actually checkable
    `session` - The session from which the request originated.
  Returns:
    true if the field is dirty

### isDirty

    protected final boolean isDirty(Object old,
                                    Object current)

### isModified

    public final boolean isModified(Object oldHydratedState,
                                    Object currentState,
                                    boolean[] checkable,
                                    SessionImplementor session)

  Description copied from interface: `Type`
  Has the value been modified compared to the current database state? The difference between this and the `Type.isDirty(java.lang.Object, java.lang.Object, org.hibernate.engine.spi.SessionImplementor)` methods is that here we need to account for "partially" built values. This is really only an issue with association types. For most type implementations it is enough to simply delegate to `Type.isDirty(java.lang.Object, java.lang.Object, org.hibernate.engine.spi.SessionImplementor)` here/

  Specified by:
    `isModified` in interface `Type`
  Parameters:
    `oldHydratedState` - the database state, in a "hydrated" form, with identifiers unresolved
    `currentState` - the current state of the object
    `checkable` - which columns are actually updatable
    `session` - The session from which the request originated.
  Returns:
    true if the field has been modified

### nullSafeGet

    public final Object nullSafeGet(ResultSet rs,
                                    String[] names,
                                    SessionImplementor session,
                                    Object owner)
                             throws SQLException

  Description copied from interface: `Type`
  Extract a value of the `mapped class` from the JDBC result set. Implementors should handle possibility of null values.

  Specified by:
    `nullSafeGet` in interface `Type`
  Parameters:
    `rs` - The result set from which to extract value.
    `names` - the column names making up this type value (use to read from result set)
    `session` - The originating session
    `owner` - the parent entity
  Returns:
    The extracted value
  Throws:
    `SQLException` - An error from the JDBC driver
  See Also:
    `alternative, 2-phase property initialization`

### nullSafeGet

    public final Object nullSafeGet(ResultSet rs,
                                    String name,
                                    SessionImplementor session,
                                    Object owner)
                             throws SQLException

  Description copied from interface: `Type`
  Extract a value of the `mapped class` from the JDBC result set. Implementors should handle possibility of null values. This form might be called if the type is known to be a single-column type.

  Specified by:
    `nullSafeGet` in interface `Type`
  Parameters:
    `rs` - The result set from which to extract value.
    `name` - the column name making up this type value (use to read from result set)
    `session` - The originating session
    `owner` - the parent entity
  Returns:
    The extracted value
  Throws:
    `SQLException` - An error from the JDBC driver

### nullSafeGet

    public final T nullSafeGet(ResultSet rs,
                               String name,
                               SessionImplementor session)
                        throws SQLException

  Throws:
    `SQLException`

### nullSafeGet

    protected final T nullSafeGet(ResultSet rs,
                                  String name,
                                  WrapperOptions options)
                           throws SQLException

  Throws:
    `SQLException`

### get

    public Object get(ResultSet rs,
                      String name,
                      SessionImplementor session)
               throws HibernateException,
                      SQLException

  Throws:
    `HibernateException`
    `SQLException`

### nullSafeSet

    public final void nullSafeSet(PreparedStatement st,
                                  Object value,
                                  int index,
                                  SessionImplementor session)
                           throws SQLException

  Description copied from interface: `Type`
  Bind a value represented by an instance of the `mapped class` to the JDBC prepared statement. Implementors should handle possibility of null values. A multi-column type should bind parameters starting from `index`.

  Specified by:
    `nullSafeSet` in interface `Type`
  Parameters:
    `st` - The JDBC prepared statement to which to bind
    `value` - the object to write
    `index` - starting parameter bind index
    `session` - The originating session
  Throws:
    `SQLException` - An error from the JDBC driver

### nullSafeSet

    protected final void nullSafeSet(PreparedStatement st,
                                     Object value,
                                     int index,
                                     WrapperOptions options)
                              throws SQLException

  Throws:
    `SQLException`

### remapSqlTypeDescriptor

    protected SqlTypeDescriptor remapSqlTypeDescriptor(WrapperOptions options)

### set

    public void set(PreparedStatement st,
                    T value,
                    int index,
                    SessionImplementor session)
             throws HibernateException,
                    SQLException

  Throws:
    `HibernateException`
    `SQLException`

### toLoggableString

    public final String toLoggableString(Object value,
                                         SessionFactoryImplementor factory)

  Description copied from interface: `Type`
  Generate a representation of the value for logging purposes.

  Specified by:
    `toLoggableString` in interface `Type`
  Parameters:
    `value` - The value to be logged
    `factory` - The session factory
  Returns:
    The loggable representation

### setToXMLNode

    public final void setToXMLNode(org.dom4j.Node node,
                                   Object value,
                                   SessionFactoryImplementor factory)

  Description copied from interface: `Type`
  A representation of the value to be embedded in an XML element.

  Specified by:
    `setToXMLNode` in interface `Type`
  Parameters:
    `node` - The XML node to which to write the value
    `value` - The value to write
    `factory` - The session factory

### fromXMLNode

    public final Object fromXMLNode(org.dom4j.Node xml,
                                    Mapping factory)

  Description copied from interface: `Type`
  Parse the XML representation of an instance.

  Specified by:
    `fromXMLNode` in interface `Type`
  Parameters:
    `xml` - The XML node from which to read the value
    `factory` - The session factory
  Returns:
    an instance of the `mapped class`

### isMutable

    public final boolean isMutable()

  Description copied from interface: `Type`
  Are objects of this type mutable. (With respect to the referencing object ... entities and collections are considered immutable because they manage their own internal state.)

  Specified by:
    `isMutable` in interface `Type`
  Returns:
    boolean

### deepCopy

    public final Object deepCopy(Object value,
                                 SessionFactoryImplementor factory)

  Description copied from interface: `Type`
  Return a deep copy of the persistent state, stopping at entities and at collections.

  Specified by:
    `deepCopy` in interface `Type`
  Parameters:
    `value` - The value to be copied
    `factory` - The session factory
  Returns:
    The deep copy

### deepCopy

    protected final T deepCopy(T value)

### disassemble

    public final Serializable disassemble(Object value,
                                          SessionImplementor session,
                                          Object owner)
                                   throws HibernateException

  Description copied from interface: `Type`
  Return a disassembled representation of the object. This is the value Hibernate will use in second level caching, so care should be taken to break values down to their simplest forms; for entities especially, this means breaking them down into their constituent parts.

  Specified by:
    `disassemble` in interface `Type`
  Parameters:
    `value` - the value to cache
    `session` - the originating session
    `owner` - optional parent entity object (needed for collections)
  Returns:
    the disassembled, deep cloned state
  Throws:
    `HibernateException` - An error from Hibernate

### assemble

    public final Object assemble(Serializable cached,
                                 SessionImplementor session,
                                 Object owner)
                          throws HibernateException

  Description copied from interface: `Type`
  Reconstruct the object from its disassembled state. This method is the reciprocal of `Type.disassemble(java.lang.Object, org.hibernate.engine.spi.SessionImplementor, java.lang.Object)`

  Specified by:
    `assemble` in interface `Type`
  Parameters:
    `cached` - the disassembled state from the cache
    `session` - the originating session
    `owner` - the parent entity object
  Returns:
    the (re)assembled object
  Throws:
    `HibernateException` - An error from Hibernate

### beforeAssemble

    public final void beforeAssemble(Serializable cached,
                                     SessionImplementor session)

  Description copied from interface: `Type`
  Called before assembling a query result set from the query cache, to allow batch fetching of entities missing from the second-level cache.

  Specified by:
    `beforeAssemble` in interface `Type`
  Parameters:
    `cached` - The key
    `session` - The originating session

### hydrate

    public final Object hydrate(ResultSet rs,
                                String[] names,
                                SessionImplementor session,
                                Object owner)
                         throws HibernateException,
                                SQLException

  Description copied from interface: `Type`
  Extract a value from the JDBC result set. This is useful for 2-phase property initialization - the second phase is a call to `Type.resolve(java.lang.Object, org.hibernate.engine.spi.SessionImplementor, java.lang.Object)` This hydrated value will be either:
  - in the case of an entity or collection type, the key
  - otherwise, the value itself

  Specified by:
    `hydrate` in interface `Type`
  Parameters:
    `rs` - The JDBC result set
    `names` - the column names making up this type value (use to read from result set)
    `session` - The originating session
    `owner` - the parent entity
  Returns:
    An entity or collection key, or an actual value.
  Throws:
    `HibernateException` - An error from Hibernate
    `SQLException` - An error from the JDBC driver
  See Also:
    `Type.resolve(java.lang.Object, org.hibernate.engine.spi.SessionImplementor, java.lang.Object)`

### resolve

    public final Object resolve(Object value,
                                SessionImplementor session,
                                Object owner)
                         throws HibernateException

  Description copied from interface: `Type`
  The second phase of 2-phase loading. Only really pertinent for entities and collections. Here we resolve the identifier to an entity or collection instance

  Specified by:
    `resolve` in interface `Type`
  Parameters:
    `value` - an identifier or value returned by `hydrate()`
    `session` - the session
    `owner` - the parent entity
  Returns:
    the given value, or the value associated with the identifier
  Throws:
    `HibernateException` - An error from Hibernate
  See Also:
    `Type.hydrate(java.sql.ResultSet, java.lang.String[], org.hibernate.engine.spi.SessionImplementor, java.lang.Object)`

### semiResolve

    public final Object semiResolve(Object value,
                                    SessionImplementor session,
                                    Object owner)
                             throws HibernateException

  Description copied from interface: `Type`
  Given a hydrated, but unresolved value, return a value that may be used to reconstruct property-ref associations.

  Specified by:
    `semiResolve` in interface `Type`
  Parameters:
    `value` - The unresolved, hydrated value
    `session` - THe originating session
    `owner` - The value owner
  Returns:
    The semi-resolved value
  Throws:
    `HibernateException` - An error from Hibernate

### getSemiResolvedType

    public final Type getSemiResolvedType(SessionFactoryImplementor factory)

  Description copied from interface: `Type`
  As part of 2-phase loading, when we perform resolving what is the resolved type for this type? Generally speaking the type and its semi-resolved type will be the same. The main deviation from this is in the case of an entity where the type would be the entity type and semi-resolved type would be its identifier type

  Specified by:
    `getSemiResolvedType` in interface `Type`
  Parameters:
    `factory` - The session factory
  Returns:
    The semi-resolved type

### replace

    public final Object replace(Object original,
                                Object target,
                                SessionImplementor session,
                                Object owner,
                                Map copyCache)

  Description copied from interface: `Type`
  During merge, replace the existing (target) value in the entity we are merging to with a new (original) value from the detached entity we are merging. For immutable objects, or null values, it is safe to simply return the first parameter. For mutable objects, it is safe to return a copy of the first parameter. For objects with component values, it might make sense to recursively replace component values.

  Specified by:
    `replace` in interface `Type`
  Parameters:
    `original` - the value from the detached entity being merged
    `target` - the value in the managed entity
    `session` - The originating session
    `owner` - The owner of the value
    `copyCache` - The cache of already copied/replaced values
  Returns:
    the value to be merged

### replace

    public Object replace(Object original,
                          Object target,
                          SessionImplementor session,
                          Object owner,
                          Map copyCache,
                          ForeignKeyDirection foreignKeyDirection)

  Description copied from interface: `Type`
  During merge, replace the existing (target) value in the entity we are merging to with a new (original) value from the detached entity we are merging. For immutable objects, or null values, it is safe to simply return the first parameter. For mutable objects, it is safe to return a copy of the first parameter. For objects with component values, it might make sense to recursively replace component values.

  Specified by:
    `replace` in interface `Type`
  Parameters:
    `original` - the value from the detached entity being merged
    `target` - the value in the managed entity
    `session` - The originating session
    `owner` - The owner of the value
    `copyCache` - The cache of already copied/replaced values
    `foreignKeyDirection` - For associations, which direction does the foreign key point?
  Returns:
    the value to be merged

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001-2012 Red Hat, Inc. All Rights Reserved.